%% Parmetros y abrimos sistema simulink

m = 0.16;
R = 0.0285;
g = -9.8;
L = 0.43;
d = 0.03;
J = 5.1984e-5;

nPts= 1e3;
t= linspace(0, 40, nPts)';
U= ones(nPts,1);


open_system('balancin_sistema');
[tsal, ~, sal]= sim('balancin_sistema', t, [], [t,U]);
plot(tsal,sal)

%% Modelo en espacio de estados

[A,B,C,D] = linmod('balancin_sistema')
[num,den] = ss2tf(A,B,C,D);
ball_ss = ss(A,B,C,D);
figure
lsim(ball_ss,U,t)

%% Seleccionamos los polos

p1 = -1.5;
p2 = -1;

K = place(A,B,[p1,p2])
t = 0:0.01:5;
u = 0.25*ones(size(t));
sys_cl = ss(A-B*K,B,C,D);
[y,t,x] = lsim(sys_cl,u,t);
plot(t,y)

%% Incorporamos ganancia en la referencia

u=ones(size(t));
Nbar=rscale(ball_ss,K)
[y,t,x] = lsim(Nbar*sys_cl,u,t);
plot(t,y)

%% Filtro Kalman

nPts= 1e3;
t= linspace(0, 40, nPts)';
U= ones(nPts,1);

open_system('ball_lc_Kalman');
[tsal, ~, sal]= sim('ball_lc_Kalman', t, [], [t,U]);
plot(tsal,sal)
