%% Control terico del sistema
%% Parmetros y funcin de transferencia

m = 0.16;
R = 0.0285;
g = -9.8;
L = 0.43;
d = 0.03;
J = 5.1984e-5;

s=tf('s');

G=-(m*g*d)/(L*((J/R^2)+m)*s^2)

%% Controlador PID

%% P
Kp=1;
C=pid(Kp);
sys_cl=feedback(C*G,1)
step(sys_cl)
axis([0 20 0 2])

%% PD
Kp=1;
Kd=10;
C=pid(Kp,0,Kd);
sys_cl=feedback(C*G,1)
step(sys_cl)
axis([0 20 0 1.2])

%% PID
Kp=1
Ki=2
Kd=60
C=pid(Kp, Ki, Kd);
sys_cl=feedback(C*G,1)
step(sys_cl)
axis([0 5 0 1.2])


%% Lugar de las raices
rlocus(G)
sgrid(0.7, 1.9)
axis([-5 5 -2 2])
zo=0.01;
po=5;
C=tf([1 zo], [1 po]);
rlocus(C*G);
sgrid(0.70, 1.9);
[k, polos]=rlocfind(C*G)

sys_cl=feedback(k*C*G,1);
step(sys_cl)
axis([0 5 0 1.2])

%% PID discreto
Ts=1/50;
Gd=c2d(G,Ts,'zoh')

[x,t]=step(0.1*Gd,5);
stairs(t,x)


%% P
Kp=100;
sys_cl=feedback(Kp*Gd,1);

[x,t]=step(0.1*sys_cl,5);
stairs(t,x)

%% PD 
z=tf('z',Ts);

Kp=100;
Kd=20;

C=((Kp+Kd)*z^2-(Kp+2*Kd)*z+Kd)/(z^2+z);

sys_cl=feedback(C*Gd,1);

[x,t]=step(0.1*sys_cl,5);
stairs(t,x)


%% PID
z=tf('z',Ts);

Kp=2000;
Kd=20;

C=((Kp+Kd)*z^2-(Kp+2*Kd)*z+Kd)/(z^2+z);

sys_cl=feedback(C*Gd,1);

[x,t]=step(0.1*sys_cl,5);
stairs(t,x)