/*
 * File: sensorsharp.c
 *
 * Code generated for Simulink model 'sensorsharp'.
 *
 * Model version                  : 1.47
 * Simulink Coder version         : 8.12 (R2017a) 16-Feb-2017
 * C/C++ source code generated on : Tue Jun 18 18:54:30 2019
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Atmel->AVR
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "sensorsharp.h"
#include "sensorsharp_private.h"
#include "sensorsharp_dt.h"

/* Block signals (auto storage) */
B_sensorsharp_T sensorsharp_B;

/* Block states (auto storage) */
DW_sensorsharp_T sensorsharp_DW;

/* Real-time model */
RT_MODEL_sensorsharp_T sensorsharp_M_;
RT_MODEL_sensorsharp_T *const sensorsharp_M = &sensorsharp_M_;
static void rate_monotonic_scheduler(void);

/*
 * Set which subrates need to run this base step (base rate always runs).
 * This function must be called prior to calling the model step function
 * in order to "remember" which rates need to run this base step.  The
 * buffering of events allows for overlapping preemption.
 */
void sensorsharp_SetEventsForThisBaseStep(boolean_T *eventFlags)
{
  /* Task runs when its counter is zero, computed via rtmStepTask macro */
  eventFlags[1] = ((boolean_T)rtmStepTask(sensorsharp_M, 1));
}

/*
 *   This function updates active task flag for each subrate
 * and rate transition flags for tasks that exchange data.
 * The function assumes rate-monotonic multitasking scheduler.
 * The function must be called at model base rate so that
 * the generated code self-manages all its subrates and rate
 * transition flags.
 */
static void rate_monotonic_scheduler(void)
{
  /* Compute which subrates run during the next base time step.  Subrates
   * are an integer multiple of the base rate counter.  Therefore, the subtask
   * counter is reset when it reaches its limit (zero means run).
   */
  (sensorsharp_M->Timing.TaskCounters.TID[1])++;
  if ((sensorsharp_M->Timing.TaskCounters.TID[1]) > 4) {/* Sample time: [0.01s, 0.0s] */
    sensorsharp_M->Timing.TaskCounters.TID[1] = 0;
  }
}

/* Model step function for TID0 */
void sensorsharp_step0(void)           /* Sample time: [0.002s, 0.0s] */
{
  {                                    /* Sample time: [0.002s, 0.0s] */
    rate_monotonic_scheduler();
  }

  /* External mode */
  rtExtModeUploadCheckTrigger(2);
  rtExtModeUpload(0, sensorsharp_M->Timing.taskTime0);

  /* signal main to stop simulation */
  {                                    /* Sample time: [0.002s, 0.0s] */
    if ((rtmGetTFinal(sensorsharp_M)!=-1) &&
        !((rtmGetTFinal(sensorsharp_M)-sensorsharp_M->Timing.taskTime0) >
          sensorsharp_M->Timing.taskTime0 * (DBL_EPSILON))) {
      rtmSetErrorStatus(sensorsharp_M, "Simulation finished");
    }

    if (rtmGetStopRequested(sensorsharp_M)) {
      rtmSetErrorStatus(sensorsharp_M, "Simulation finished");
    }
  }

  /* Update absolute time */
  /* The "clockTick0" counts the number of times the code of this task has
   * been executed. The absolute time is the multiplication of "clockTick0"
   * and "Timing.stepSize0". Size of "clockTick0" ensures timer will not
   * overflow during the application lifespan selected.
   */
  sensorsharp_M->Timing.taskTime0 =
    (++sensorsharp_M->Timing.clockTick0) * sensorsharp_M->Timing.stepSize0;
}

/* Model step function for TID1 */
void sensorsharp_step1(void)           /* Sample time: [0.01s, 0.0s] */
{
  uint16_T rtb_AnalogImputSensor_0;
  int16_T j;
  int16_T k;
  int16_T a;
  int16_T b_j;
  int16_T b_k;
  real_T rtb_error;
  real_T rtb_TSamp;
  real_T u0;
  uint8_T tmp;
  boolean_T exitg1;

  /* MATLAB Function: '<Root>/MATLAB Function 1' incorporates:
   *  S-Function (sfix_udelay): '<Root>/Delay'
   */
  /* MATLAB Function 'MATLAB Function 1': '<S1>:1' */
  /* '<S1>:1:2' sensorfilter=0.0; */
  rtb_error = 0.0;

  /* sortedValues=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]; */
  /* '<S1>:1:4' sortedValues=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]; */
  memset(&sensorsharp_B.sortedValues[0], 0, 20U * sizeof(real_T));

  /* '<S1>:1:5' for a=1:20 */
  for (a = 0; a < 20; a++) {
    /*  medidas */
    /* '<S1>:1:6' if(sensor(a)<sortedValues(1) || a==1) */
    if (sensorsharp_DW.Delay_X[a] < sensorsharp_B.sortedValues[0]) {
      /* '<S1>:1:7' j=1; */
      j = 0;

      /* inserta en la primera posicion */
    } else if (1 + a == 1) {
      /* '<S1>:1:7' j=1; */
      j = 0;

      /* inserta en la primera posicion */
    } else {
      /* '<S1>:1:8' else */
      /* '<S1>:1:9' for j=2:a */
      j = 1;
      b_j = 0;
      exitg1 = false;
      while ((!exitg1) && (b_j <= a - 1)) {
        j = b_j + 1;

        /* '<S1>:1:10' if(sortedValues(j-1)<=sensor(a)&& sortedValues(j)>=sensor(a)) */
        if ((sensorsharp_B.sortedValues[b_j] <= sensorsharp_DW.Delay_X[a]) &&
            (sensorsharp_B.sortedValues[b_j + 1] >= sensorsharp_DW.Delay_X[a]))
        {
          /* j is insert position */
          exitg1 = true;
        } else {
          b_j++;
        }
      }
    }

    /* '<S1>:1:16' for k=a:-1:j+1 */
    b_j = (int16_T)((real_T)(j - a) / -1.0);
    for (b_k = 0; b_k < b_j; b_k++) {
      k = a - b_k;

      /* movemos los valores una posicin */
      /* '<S1>:1:17' sortedValues(k)=sortedValues(k-1); */
      sensorsharp_B.sortedValues[k] = sensorsharp_B.sortedValues[k - 1];
    }

    /* '<S1>:1:19' sortedValues(j)=sensor(a); */
    sensorsharp_B.sortedValues[j] = sensorsharp_DW.Delay_X[a];

    /* se inserta lectura actual */
  }

  /* '<S1>:1:21' for a=8:12 */
  for (a = 0; a < 5; a++) {
    /* hacemos media de los intermedios */
    /* '<S1>:1:22' sensorfilter=sensorfilter+sortedValues(a); */
    rtb_error += sensorsharp_B.sortedValues[a + 7];
  }

  /* '<S1>:1:24' sensorfilter=sensorfilter/5; */
  rtb_error /= 5.0;

  /* MATLAB Function: '<Root>/MATLAB Function 2' incorporates:
   *  MATLAB Function: '<Root>/MATLAB Function 1'
   */
  /* MATLAB Function 'MATLAB Function 2': '<S2>:1' */
  /* '<S2>:1:3' poscm=-0.1138*posv+77.958; */
  sensorsharp_B.poscm = -0.1138 * rtb_error + 77.958;

  /* DataTypeConversion: '<Root>/Data Type Conversion1' */
  rtb_error = floor(sensorsharp_B.poscm);
  if (rtIsNaN(rtb_error) || rtIsInf(rtb_error)) {
    rtb_error = 0.0;
  } else {
    rtb_error = fmod(rtb_error, 65536.0);
  }

  sensorsharp_B.DataTypeConversion1 = rtb_error < 0.0 ? (uint16_T)-(int16_T)
    (uint16_T)-rtb_error : (uint16_T)rtb_error;

  /* End of DataTypeConversion: '<Root>/Data Type Conversion1' */

  /* S-Function (Lcd): '<Root>/S-Function Builder' */
  Lcd_Outputs_wrapper(&sensorsharp_B.DataTypeConversion1,
                      &sensorsharp_DW.SFunctionBuilder_DSTATE);

  /* Constant: '<Root>/Constant2' */
  sensorsharp_B.Constant2 = sensorsharp_P.Constant2_Value;

  /* Sum: '<Root>/Sum1' */
  rtb_error = sensorsharp_B.Constant2 - sensorsharp_B.poscm;

  /* SampleTimeMath: '<S7>/TSamp' incorporates:
   *  Gain: '<S4>/Derivative Gain'
   *
   * About '<S7>/TSamp':
   *  y = u * K where K = 1 / ( w * Ts )
   */
  rtb_TSamp = sensorsharp_P.PIDController_D * rtb_error *
    sensorsharp_P.TSamp_WtEt;

  /* Sum: '<S4>/Sum' incorporates:
   *  Delay: '<S7>/UD'
   *  DiscreteIntegrator: '<S4>/Integrator'
   *  Gain: '<S4>/Proportional Gain'
   *  Sum: '<S7>/Diff'
   */
  sensorsharp_B.Sum = (sensorsharp_P.PIDController_P * rtb_error +
                       sensorsharp_DW.Integrator_DSTATE) + (rtb_TSamp -
    sensorsharp_DW.UD_DSTATE);

  /* MATLAB Function: '<Root>/MATLAB Function 3' */
  /* MATLAB Function 'MATLAB Function 3': '<S3>:1' */
  /* '<S3>:1:3' grados = ((pid - (-180))*(180 - 0))/(180 - (-180)) + 0; */
  u0 = (sensorsharp_B.Sum - -180.0) * 180.0 / 360.0;

  /* Saturate: '<Root>/Saturation' */
  if (u0 > sensorsharp_P.Saturation_UpperSat) {
    sensorsharp_B.Saturation = sensorsharp_P.Saturation_UpperSat;
  } else if (u0 < sensorsharp_P.Saturation_LowerSat) {
    sensorsharp_B.Saturation = sensorsharp_P.Saturation_LowerSat;
  } else {
    sensorsharp_B.Saturation = u0;
  }

  /* End of Saturate: '<Root>/Saturation' */
  /* DataTypeConversion: '<S6>/Data Type Conversion' */
  if (sensorsharp_B.Saturation < 256.0) {
    if (sensorsharp_B.Saturation >= 0.0) {
      tmp = (uint8_T)sensorsharp_B.Saturation;
    } else {
      tmp = 0U;
    }
  } else {
    tmp = MAX_uint8_T;
  }

  /* End of DataTypeConversion: '<S6>/Data Type Conversion' */

  /* S-Function (arduinoservowrite_sfcn): '<S6>/Servo Write' */
  MW_servoWrite(sensorsharp_P.ServoWrite_p1, tmp);

  /* S-Function (arduinoanaloginput_sfcn): '<Root>/Analog Imput Sensor' */
  rtb_AnalogImputSensor_0 = MW_analogRead(sensorsharp_P.AnalogImputSensor_p1);

  /* DataTypeConversion: '<S5>/Data Type Conversion' incorporates:
   *  Constant: '<Root>/Constant1'
   */
  if (sensorsharp_P.Constant1_Value < 256.0) {
    if (sensorsharp_P.Constant1_Value >= 0.0) {
      tmp = (uint8_T)sensorsharp_P.Constant1_Value;
    } else {
      tmp = 0U;
    }
  } else {
    tmp = MAX_uint8_T;
  }

  /* End of DataTypeConversion: '<S5>/Data Type Conversion' */

  /* S-Function (arduinoanalogoutput_sfcn): '<S5>/PWM' */
  MW_analogWrite(sensorsharp_P.PWM_pinNumber, tmp);

  /* Update for S-Function (sfix_udelay): '<Root>/Delay' incorporates:
   *  DataTypeConversion: '<Root>/Data Type Conversion3'
   *  S-Function (arduinoanaloginput_sfcn): '<Root>/Analog Imput Sensor'
   */
  for (a = 0; a < 19; a++) {
    sensorsharp_DW.Delay_X[a] = sensorsharp_DW.Delay_X[a + 1];
  }

  sensorsharp_DW.Delay_X[19] = rtb_AnalogImputSensor_0;

  /* End of Update for S-Function (sfix_udelay): '<Root>/Delay' */

  /* Update for S-Function (Lcd): '<Root>/S-Function Builder' */

  /* S-Function "Lcd_wrapper" Block: <Root>/S-Function Builder */
  Lcd_Update_wrapper(&sensorsharp_B.DataTypeConversion1,
                     &sensorsharp_DW.SFunctionBuilder_DSTATE);

  /* Update for DiscreteIntegrator: '<S4>/Integrator' incorporates:
   *  Gain: '<S4>/Integral Gain'
   */
  sensorsharp_DW.Integrator_DSTATE += sensorsharp_P.PIDController_I * rtb_error *
    sensorsharp_P.Integrator_gainval;

  /* Update for Delay: '<S7>/UD' */
  sensorsharp_DW.UD_DSTATE = rtb_TSamp;
  rtExtModeUpload(1, ((sensorsharp_M->Timing.clockTick1) * 0.01));

  /* Update absolute time */
  /* The "clockTick1" counts the number of times the code of this task has
   * been executed. The resolution of this integer timer is 0.01, which is the step size
   * of the task. Size of "clockTick1" ensures timer will not overflow during the
   * application lifespan selected.
   */
  sensorsharp_M->Timing.clockTick1++;
}

/* Model initialize function */
void sensorsharp_initialize(void)
{
  /* Registration code */

  /* initialize non-finites */
  rt_InitInfAndNaN(sizeof(real_T));

  /* initialize real-time model */
  (void) memset((void *)sensorsharp_M, 0,
                sizeof(RT_MODEL_sensorsharp_T));
  rtmSetTFinal(sensorsharp_M, -1);
  sensorsharp_M->Timing.stepSize0 = 0.002;

  /* External mode info */
  sensorsharp_M->Sizes.checksums[0] = (1368376521U);
  sensorsharp_M->Sizes.checksums[1] = (2124501209U);
  sensorsharp_M->Sizes.checksums[2] = (2996990022U);
  sensorsharp_M->Sizes.checksums[3] = (827725802U);

  {
    static const sysRanDType rtAlwaysEnabled = SUBSYS_RAN_BC_ENABLE;
    static RTWExtModeInfo rt_ExtModeInfo;
    static const sysRanDType *systemRan[4];
    sensorsharp_M->extModeInfo = (&rt_ExtModeInfo);
    rteiSetSubSystemActiveVectorAddresses(&rt_ExtModeInfo, systemRan);
    systemRan[0] = &rtAlwaysEnabled;
    systemRan[1] = &rtAlwaysEnabled;
    systemRan[2] = &rtAlwaysEnabled;
    systemRan[3] = &rtAlwaysEnabled;
    rteiSetModelMappingInfoPtr(sensorsharp_M->extModeInfo,
      &sensorsharp_M->SpecialInfo.mappingInfo);
    rteiSetChecksumsPtr(sensorsharp_M->extModeInfo,
                        sensorsharp_M->Sizes.checksums);
    rteiSetTPtr(sensorsharp_M->extModeInfo, rtmGetTPtr(sensorsharp_M));
  }

  /* block I/O */
  (void) memset(((void *) &sensorsharp_B), 0,
                sizeof(B_sensorsharp_T));

  /* states (dwork) */
  (void) memset((void *)&sensorsharp_DW, 0,
                sizeof(DW_sensorsharp_T));

  /* data type transition information */
  {
    static DataTypeTransInfo dtInfo;
    (void) memset((char_T *) &dtInfo, 0,
                  sizeof(dtInfo));
    sensorsharp_M->SpecialInfo.mappingInfo = (&dtInfo);
    dtInfo.numDataTypes = 14;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.BTransTable = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.PTransTable = &rtPTransTable;
  }

  {
    int16_T i;

    /* Start for S-Function (arduinoservowrite_sfcn): '<S6>/Servo Write' */
    MW_servoAttach(sensorsharp_P.ServoWrite_p1,
                   sensorsharp_P.ServoWrite_pinNumber);

    /* Start for S-Function (arduinoanaloginput_sfcn): '<Root>/Analog Imput Sensor' */
    MW_pinModeAnalogInput(sensorsharp_P.AnalogImputSensor_p1);

    /* Start for S-Function (arduinoanalogoutput_sfcn): '<S5>/PWM' */
    MW_pinModeOutput(sensorsharp_P.PWM_pinNumber);

    /* InitializeConditions for S-Function (sfix_udelay): '<Root>/Delay' */
    for (i = 0; i < 20; i++) {
      sensorsharp_DW.Delay_X[i] = sensorsharp_P.Delay_vinit;
    }

    /* End of InitializeConditions for S-Function (sfix_udelay): '<Root>/Delay' */

    /* InitializeConditions for S-Function (Lcd): '<Root>/S-Function Builder' */

    /* S-Function Block: <Root>/S-Function Builder */
    {
      real_T initVector[1] = { 0 };

      {
        int_T i1;
        for (i1=0; i1 < 1; i1++) {
          sensorsharp_DW.SFunctionBuilder_DSTATE = initVector[0];
        }
      }
    }

    /* InitializeConditions for DiscreteIntegrator: '<S4>/Integrator' */
    sensorsharp_DW.Integrator_DSTATE = sensorsharp_P.Integrator_IC;

    /* InitializeConditions for Delay: '<S7>/UD' */
    sensorsharp_DW.UD_DSTATE = sensorsharp_P.UD_InitialCondition;
  }
}

/* Model terminate function */
void sensorsharp_terminate(void)
{
  /* (no terminate code required) */
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
